<template>
  <single-panel class="user-setting">
    <ob-tabs
      :items="tabsItems"
      :value="selectedTab"
      value-exp="id"
      :no-border="true"
      @on-change-tab="onChangeTab"
    >
      <div class="user-setting__content">
        <component
          :is="currentComponent"
        />
      </div>
    </ob-tabs>
  </single-panel>
</template>

<script>
  import { mapGetters, mapActions } from 'vuex'
  import SinglePanel from 'common-components/src/obComponents/obSinglePanels'
  import ObTabs from 'common-components/src/obComponents/obTabs/index'
  import Markup from './Markup'
  import CostReduction from './CostReduction'
  import Autosearch from './Autosearch'

  const tabs = {
    markup: {
      title: 'Наценка',
      id: 'markup',
      component: Markup
    },
    costReduction: {
      title: 'Лимит',
      id: 'costReduction',
      component: CostReduction
    },
    autosearch: {
      title: 'Автопоиск',
      id: 'autosearch',
      component: Autosearch
    }
  }

  export default {
    name: 'CommercialPolicy',
    components: {
      SinglePanel,
      ObTabs,
    },
    data () {
      return {
        selectedTab: null
      }
    },
    mounted () {
      const type = this.$route.query.settings_type

      this.setNotification(this.$notification)
      this.onChangeTab(tabs[type] || tabs.markup)
    },
    computed: {
      ...mapGetters({
        currentSettings: 'clicarSettings_3/currentSettings'
      }),
      tabsItems () {
        return [ ...Object.values(tabs) ]
      },
      currentComponent () {
        return this.selectedTab?.component
      }
    },
    methods: {
      ...mapActions({
        setSettingsType: 'clicarSettings_3/setSettingsType',
        setNotification: 'clicarSettings_3/setNotification',
      }),
      onChangeTab (tab) {
        this.selectedTab = tab
        this.setSettingsType(tab.id)

        if (this.$route.query.settings_type !== tab.id) {
          this.$router.push({ query: { ...this.$route.query, settings_type: tab.id } })
        }
      }
    }
  }
</script>

<style scoped lang="scss">
 .user-setting {
   &__content {
     display: flex;
     flex-direction: column;
     flex-grow: 2;
     padding: 30px 20px 0 20px;
   }
   &::v-deep {
     .ob-tabs-container {
       display: flex;
       flex-direction: column;
       min-height: 100%;
     }
     .ob-tabs__content {
       flex-grow: 2;
       display: flex;
       flex-direction: column;
     }
     .ob-tabs__panel {
       padding: 10px 20px 0 20px;
       box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
     }
     .settings-container {
       display: flex;
       flex-direction: column;
       flex-grow: 2;
     }
     .ob-ctrlgroup {
       align-self: flex-start;
     }
   }
 }
</style>